unit ThreadUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ThreadUnit2, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ButtonGoSansThread: TButton;
    LabelSansThread: TLabel;
    Label1: TLabel;
    ButtonStopSansThread: TButton;
    GroupBox2: TGroupBox;
    ButtonGoAvecThread: TButton;
    LabelThread: TLabel;
    ButtonStopThread: TButton;
    ButtonShowMessage: TButton;
    ButtonShowMessageThread: TButton;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton1: TRadioButton;
    procedure ButtonGoAvecThreadClick(Sender: TObject);
    procedure ButtonShowMessageClick(Sender: TObject);
    procedure ButtonGoSansThreadClick(Sender: TObject);
    procedure ButtonStopSansThreadClick(Sender: TObject);
    procedure ButtonStopThreadClick(Sender: TObject);
  private
    Compteur2:Integer;
    Stop:Boolean;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  UnThread:TUnThread;
implementation

{$R *.DFM}

procedure TForm1.ButtonGoAvecThreadClick(Sender: TObject);
begin
  UnThread:=TUnThread.Create(True); { True : cration suspendue  il ne s'excute pas encore }
  UnThread.FreeOnTerminate:=True;//on veut une destruction automatique aprs excution.
  {valeurs possibles pour Priority :
  tpIdle	Le thread ne s'excute que lorsque le systme est inoccup. Windows n'interrompt pas les autres threads pour excuter un thread de priorit tpIdle.
  tpLowest	La priorit du thread est deux points en dessous de la normale.
  tpLower	La priorit du thread est un point en dessous de la normale.
  tpNormal	La priorit du thread est normale.
  tpHigher	La priorit du thread est un point au dessus de la normale
  tpHighest	La priorit du thread est deux points au dessus de la normale.
  tpTimeCritical	Le thread a la priorit la plus leve.}
  // dans cet exemple, l'influence de Priority n'est pas visible
  if radioButton1.Checked then UnThread.Priority:= tpIdle ;
  if radioButton2.Checked then UnThread.Priority:= tpLowest;
  if radioButton3.Checked then UnThread.Priority:= tpLower;
  if radioButton4.Checked then UnThread.Priority:= tpNormal;
  if radioButton5.Checked then UnThread.Priority:= tpHigher;
  if radioButton6.Checked then UnThread.Priority:= tpHighest;
  if radioButton7.Checked then UnThread.Priority:= tpTimeCritical;
  UnThread.Resume;    { maintenant, le thread est excut (sa procdure execute est excute) }
end;

procedure TForm1.ButtonShowMessageClick(Sender: TObject);
begin
  ShowMessage('test');
end;

procedure TForm1.ButtonGoSansThreadClick(Sender: TObject);
begin
  Compteur2:=0;
  Stop:=False;
  Form1.LabelThread.Caption:=IntToStr(Compteur2);
  While (Compteur2< 10000) and not Stop do
  begin
     inc(Compteur2);
     Form1.LabelSansThread.Caption:=IntToStr(Compteur2);
     Form1.LabelSansThread.Update;
  end;
end;

procedure TForm1.ButtonStopSansThreadClick(Sender: TObject);
begin
  Stop:=True;
end;

procedure TForm1.ButtonStopThreadClick(Sender: TObject);
begin
{Terminate initialise la proprit Terminated du thread  True, en signalant q
ue le thread doit se terminer ds que possible.
A l'inverse de l'API  Windows TerminateThread, qui force le thread  se terminer immdiatement,
la mthode Terminate demande simplement que le thread se termine.
Ceci permet au thread d'excuter tout nettoyage avant de se fermer.}

{Pour que Terminate fonctionne, la mthode Execute du thread et toute mthode appele
par Execute doit tester priodiquement Terminated et quitter lorsqu'elle vaut True.}
  if Assigned(UnThread) then UnThread.Terminate;
end;

end.



